import sys
sys.path.insert(0, 'apps/python/acSLI2/dll')
import os
import shutil

from acSLI2App.logger import Log
import acSLI2App.app as App
import acSLI2App.updater as Updater
import acSLI2App.loader as Loader


acSLI2 = 0
hasInit = False


def acMain(acVerison):
    global acSLI2, hasInit, Log

    try:
        Log.info("Start Loading acSLI2 v" + App.Version)
        Loader.ConfigLoader()
        Updater.Updater(App.Version)
        cleanInstall()

        if not Updater.instance.isOpen:
            hasInit = True
            acSLI2 = App.App()
            acSLI2.onStart()

        return "acSLI2"
        
    except Exception as e:
        Log.error("On Start: %s" % e)
 

def acUpdate(deltaT):  
    global acSLI2, hasInit

    try:
        if not Updater.instance.isOpen and not hasInit:
            hasInit = True
            acSLI2 = App.App()
            acSLI2.onStart()

        if hasInit:
            acSLI2.onUpdate()

    except Exception as e:
        Log.error("On Update: %s" % e)


def acShutdown(deltaT):  
    global acSLI2

    try:
        if not Updater.instance.isOpen:
            acSLI2.onClose()

    except Exception as e:
        Log.error("On Close: %s" % e)


def cleanInstall():
    if os.path.exists("apps/python/acSLI2/acSLI2Updater.py"):
        os.remove("apps/python/acSLI2/acSLI2Updater.py")
    if os.path.exists("apps/python/acSLI2/log.txt"):
        os.remove("apps/python/acSLI2/log.txt")
    if os.path.exists("apps/python/acSLI2/ArduinoDash/"):
        shutil.rmtree("apps/python/acSLI2/ArduinoDash")
    if os.path.exists("apps/python/acSLI2/acSLI2App/.cache"):
        os.remove("apps/python/acSLI2/acSLI2App/.cache")